Index: opengl32/opengl_ext.c
===================================================================
RCS file: /home/wine/wine/dlls/opengl32/opengl_ext.c,v
retrieving revision 1.16
diff -u -r1.16 opengl_ext.c
--- opengl32/opengl_ext.c	14 Apr 2004 23:58:33 -0000	1.16
+++ opengl32/opengl_ext.c	4 Feb 2005 16:53:19 -0000
@@ -2754,77 +3002,114 @@
   { "glVertexArrayParameteriAPPLE", "glVertexArrayParameteriAPPLE", (void *) wine_glVertexArrayParameteriAPPLE, (void **) (&func_glVertexArrayParameteriAPPLE) },
   { "glVertexArrayRangeAPPLE", "glVertexArrayRangeAPPLE", (void *) wine_glVertexArrayRangeAPPLE, (void **) (&func_glVertexArrayRangeAPPLE) },
   { "glVertexArrayRangeNV", "glVertexArrayRangeNV", (void *) wine_glVertexArrayRangeNV, (void **) (&func_glVertexArrayRangeNV) },
+  { "glVertexAttrib1d", "glVertexAttrib1d", (void *) wine_glVertexAttrib1d, (void **) (&func_glVertexAttrib1d) },
   { "glVertexAttrib1dARB", "glVertexAttrib1dARB", (void *) wine_glVertexAttrib1dARB, (void **) (&func_glVertexAttrib1dARB) },
   { "glVertexAttrib1dNV", "glVertexAttrib1dNV", (void *) wine_glVertexAttrib1dNV, (void **) (&func_glVertexAttrib1dNV) },
+  { "glVertexAttrib1dv", "glVertexAttrib1dv", (void *) wine_glVertexAttrib1dv, (void **) (&func_glVertexAttrib1dv) },
   { "glVertexAttrib1dvARB", "glVertexAttrib1dvARB", (void *) wine_glVertexAttrib1dvARB, (void **) (&func_glVertexAttrib1dvARB) },
   { "glVertexAttrib1dvNV", "glVertexAttrib1dvNV", (void *) wine_glVertexAttrib1dvNV, (void **) (&func_glVertexAttrib1dvNV) },
+  { "glVertexAttrib1f", "glVertexAttrib1f", (void *) wine_glVertexAttrib1f, (void **) (&func_glVertexAttrib1f) },
   { "glVertexAttrib1fARB", "glVertexAttrib1fARB", (void *) wine_glVertexAttrib1fARB, (void **) (&func_glVertexAttrib1fARB) },
   { "glVertexAttrib1fNV", "glVertexAttrib1fNV", (void *) wine_glVertexAttrib1fNV, (void **) (&func_glVertexAttrib1fNV) },
+  { "glVertexAttrib1fv", "glVertexAttrib1fv", (void *) wine_glVertexAttrib1fv, (void **) (&func_glVertexAttrib1fv) },
   { "glVertexAttrib1fvARB", "glVertexAttrib1fvARB", (void *) wine_glVertexAttrib1fvARB, (void **) (&func_glVertexAttrib1fvARB) },
   { "glVertexAttrib1fvNV", "glVertexAttrib1fvNV", (void *) wine_glVertexAttrib1fvNV, (void **) (&func_glVertexAttrib1fvNV) },
   { "glVertexAttrib1hNV", "glVertexAttrib1hNV", (void *) wine_glVertexAttrib1hNV, (void **) (&func_glVertexAttrib1hNV) },
   { "glVertexAttrib1hvNV", "glVertexAttrib1hvNV", (void *) wine_glVertexAttrib1hvNV, (void **) (&func_glVertexAttrib1hvNV) },
+  { "glVertexAttrib1s", "glVertexAttrib1s", (void *) wine_glVertexAttrib1s, (void **) (&func_glVertexAttrib1s) },
   { "glVertexAttrib1sARB", "glVertexAttrib1sARB", (void *) wine_glVertexAttrib1sARB, (void **) (&func_glVertexAttrib1sARB) },
   { "glVertexAttrib1sNV", "glVertexAttrib1sNV", (void *) wine_glVertexAttrib1sNV, (void **) (&func_glVertexAttrib1sNV) },
+  { "glVertexAttrib1sv", "glVertexAttrib1sv", (void *) wine_glVertexAttrib1sv, (void **) (&func_glVertexAttrib1sv) },
   { "glVertexAttrib1svARB", "glVertexAttrib1svARB", (void *) wine_glVertexAttrib1svARB, (void **) (&func_glVertexAttrib1svARB) },
   { "glVertexAttrib1svNV", "glVertexAttrib1svNV", (void *) wine_glVertexAttrib1svNV, (void **) (&func_glVertexAttrib1svNV) },
+  { "glVertexAttrib2d", "glVertexAttrib2d", (void *) wine_glVertexAttrib2d, (void **) (&func_glVertexAttrib2d) },
   { "glVertexAttrib2dARB", "glVertexAttrib2dARB", (void *) wine_glVertexAttrib2dARB, (void **) (&func_glVertexAttrib2dARB) },
   { "glVertexAttrib2dNV", "glVertexAttrib2dNV", (void *) wine_glVertexAttrib2dNV, (void **) (&func_glVertexAttrib2dNV) },
+  { "glVertexAttrib2dv", "glVertexAttrib2dv", (void *) wine_glVertexAttrib2dv, (void **) (&func_glVertexAttrib2dv) },
   { "glVertexAttrib2dvARB", "glVertexAttrib2dvARB", (void *) wine_glVertexAttrib2dvARB, (void **) (&func_glVertexAttrib2dvARB) },
   { "glVertexAttrib2dvNV", "glVertexAttrib2dvNV", (void *) wine_glVertexAttrib2dvNV, (void **) (&func_glVertexAttrib2dvNV) },
+  { "glVertexAttrib2f", "glVertexAttrib2f", (void *) wine_glVertexAttrib2f, (void **) (&func_glVertexAttrib2f) },
   { "glVertexAttrib2fARB", "glVertexAttrib2fARB", (void *) wine_glVertexAttrib2fARB, (void **) (&func_glVertexAttrib2fARB) },
   { "glVertexAttrib2fNV", "glVertexAttrib2fNV", (void *) wine_glVertexAttrib2fNV, (void **) (&func_glVertexAttrib2fNV) },
+  { "glVertexAttrib2fv", "glVertexAttrib2fv", (void *) wine_glVertexAttrib2fv, (void **) (&func_glVertexAttrib2fv) },
   { "glVertexAttrib2fvARB", "glVertexAttrib2fvARB", (void *) wine_glVertexAttrib2fvARB, (void **) (&func_glVertexAttrib2fvARB) },
   { "glVertexAttrib2fvNV", "glVertexAttrib2fvNV", (void *) wine_glVertexAttrib2fvNV, (void **) (&func_glVertexAttrib2fvNV) },
   { "glVertexAttrib2hNV", "glVertexAttrib2hNV", (void *) wine_glVertexAttrib2hNV, (void **) (&func_glVertexAttrib2hNV) },
   { "glVertexAttrib2hvNV", "glVertexAttrib2hvNV", (void *) wine_glVertexAttrib2hvNV, (void **) (&func_glVertexAttrib2hvNV) },
+  { "glVertexAttrib2s", "glVertexAttrib2s", (void *) wine_glVertexAttrib2s, (void **) (&func_glVertexAttrib2s) },
   { "glVertexAttrib2sARB", "glVertexAttrib2sARB", (void *) wine_glVertexAttrib2sARB, (void **) (&func_glVertexAttrib2sARB) },
   { "glVertexAttrib2sNV", "glVertexAttrib2sNV", (void *) wine_glVertexAttrib2sNV, (void **) (&func_glVertexAttrib2sNV) },
+  { "glVertexAttrib2sv", "glVertexAttrib2sv", (void *) wine_glVertexAttrib2sv, (void **) (&func_glVertexAttrib2sv) },
   { "glVertexAttrib2svARB", "glVertexAttrib2svARB", (void *) wine_glVertexAttrib2svARB, (void **) (&func_glVertexAttrib2svARB) },
   { "glVertexAttrib2svNV", "glVertexAttrib2svNV", (void *) wine_glVertexAttrib2svNV, (void **) (&func_glVertexAttrib2svNV) },
+  { "glVertexAttrib3d", "glVertexAttrib3d", (void *) wine_glVertexAttrib3d, (void **) (&func_glVertexAttrib3d) },
   { "glVertexAttrib3dARB", "glVertexAttrib3dARB", (void *) wine_glVertexAttrib3dARB, (void **) (&func_glVertexAttrib3dARB) },
   { "glVertexAttrib3dNV", "glVertexAttrib3dNV", (void *) wine_glVertexAttrib3dNV, (void **) (&func_glVertexAttrib3dNV) },
+  { "glVertexAttrib3dv", "glVertexAttrib3dv", (void *) wine_glVertexAttrib3dv, (void **) (&func_glVertexAttrib3dv) },
   { "glVertexAttrib3dvARB", "glVertexAttrib3dvARB", (void *) wine_glVertexAttrib3dvARB, (void **) (&func_glVertexAttrib3dvARB) },
   { "glVertexAttrib3dvNV", "glVertexAttrib3dvNV", (void *) wine_glVertexAttrib3dvNV, (void **) (&func_glVertexAttrib3dvNV) },
+  { "glVertexAttrib3f", "glVertexAttrib3f", (void *) wine_glVertexAttrib3f, (void **) (&func_glVertexAttrib3f) },
   { "glVertexAttrib3fARB", "glVertexAttrib3fARB", (void *) wine_glVertexAttrib3fARB, (void **) (&func_glVertexAttrib3fARB) },
   { "glVertexAttrib3fNV", "glVertexAttrib3fNV", (void *) wine_glVertexAttrib3fNV, (void **) (&func_glVertexAttrib3fNV) },
+  { "glVertexAttrib3fv", "glVertexAttrib3fv", (void *) wine_glVertexAttrib3fv, (void **) (&func_glVertexAttrib3fv) },
   { "glVertexAttrib3fvARB", "glVertexAttrib3fvARB", (void *) wine_glVertexAttrib3fvARB, (void **) (&func_glVertexAttrib3fvARB) },
   { "glVertexAttrib3fvNV", "glVertexAttrib3fvNV", (void *) wine_glVertexAttrib3fvNV, (void **) (&func_glVertexAttrib3fvNV) },
   { "glVertexAttrib3hNV", "glVertexAttrib3hNV", (void *) wine_glVertexAttrib3hNV, (void **) (&func_glVertexAttrib3hNV) },
   { "glVertexAttrib3hvNV", "glVertexAttrib3hvNV", (void *) wine_glVertexAttrib3hvNV, (void **) (&func_glVertexAttrib3hvNV) },
+  { "glVertexAttrib3s", "glVertexAttrib3s", (void *) wine_glVertexAttrib3s, (void **) (&func_glVertexAttrib3s) },
   { "glVertexAttrib3sARB", "glVertexAttrib3sARB", (void *) wine_glVertexAttrib3sARB, (void **) (&func_glVertexAttrib3sARB) },
   { "glVertexAttrib3sNV", "glVertexAttrib3sNV", (void *) wine_glVertexAttrib3sNV, (void **) (&func_glVertexAttrib3sNV) },
+  { "glVertexAttrib3sv", "glVertexAttrib3sv", (void *) wine_glVertexAttrib3sv, (void **) (&func_glVertexAttrib3sv) },
   { "glVertexAttrib3svARB", "glVertexAttrib3svARB", (void *) wine_glVertexAttrib3svARB, (void **) (&func_glVertexAttrib3svARB) },
   { "glVertexAttrib3svNV", "glVertexAttrib3svNV", (void *) wine_glVertexAttrib3svNV, (void **) (&func_glVertexAttrib3svNV) },
+  { "glVertexAttrib4Nbv", "glVertexAttrib4Nbv", (void *) wine_glVertexAttrib4Nbv, (void **) (&func_glVertexAttrib4Nbv) },
   { "glVertexAttrib4NbvARB", "glVertexAttrib4NbvARB", (void *) wine_glVertexAttrib4NbvARB, (void **) (&func_glVertexAttrib4NbvARB) },
+  { "glVertexAttrib4Niv", "glVertexAttrib4Niv", (void *) wine_glVertexAttrib4Niv, (void **) (&func_glVertexAttrib4Niv) },
   { "glVertexAttrib4NivARB", "glVertexAttrib4NivARB", (void *) wine_glVertexAttrib4NivARB, (void **) (&func_glVertexAttrib4NivARB) },
+  { "glVertexAttrib4Nsv", "glVertexAttrib4Nsv", (void *) wine_glVertexAttrib4Nsv, (void **) (&func_glVertexAttrib4Nsv) },
   { "glVertexAttrib4NsvARB", "glVertexAttrib4NsvARB", (void *) wine_glVertexAttrib4NsvARB, (void **) (&func_glVertexAttrib4NsvARB) },
+  { "glVertexAttrib4Nub", "glVertexAttrib4Nub", (void *) wine_glVertexAttrib4Nub, (void **) (&func_glVertexAttrib4Nub) },
   { "glVertexAttrib4NubARB", "glVertexAttrib4NubARB", (void *) wine_glVertexAttrib4NubARB, (void **) (&func_glVertexAttrib4NubARB) },
+  { "glVertexAttrib4Nubv", "glVertexAttrib4Nubv", (void *) wine_glVertexAttrib4Nubv, (void **) (&func_glVertexAttrib4Nubv) },
   { "glVertexAttrib4NubvARB", "glVertexAttrib4NubvARB", (void *) wine_glVertexAttrib4NubvARB, (void **) (&func_glVertexAttrib4NubvARB) },
+  { "glVertexAttrib4Nuiv", "glVertexAttrib4Nuiv", (void *) wine_glVertexAttrib4Nuiv, (void **) (&func_glVertexAttrib4Nuiv) },
   { "glVertexAttrib4NuivARB", "glVertexAttrib4NuivARB", (void *) wine_glVertexAttrib4NuivARB, (void **) (&func_glVertexAttrib4NuivARB) },
+  { "glVertexAttrib4Nusv", "glVertexAttrib4Nusv", (void *) wine_glVertexAttrib4Nusv, (void **) (&func_glVertexAttrib4Nusv) },
   { "glVertexAttrib4NusvARB", "glVertexAttrib4NusvARB", (void *) wine_glVertexAttrib4NusvARB, (void **) (&func_glVertexAttrib4NusvARB) },
+  { "glVertexAttrib4bv", "glVertexAttrib4bv", (void *) wine_glVertexAttrib4bv, (void **) (&func_glVertexAttrib4bv) },
   { "glVertexAttrib4bvARB", "glVertexAttrib4bvARB", (void *) wine_glVertexAttrib4bvARB, (void **) (&func_glVertexAttrib4bvARB) },
+  { "glVertexAttrib4d", "glVertexAttrib4d", (void *) wine_glVertexAttrib4d, (void **) (&func_glVertexAttrib4d) },
   { "glVertexAttrib4dARB", "glVertexAttrib4dARB", (void *) wine_glVertexAttrib4dARB, (void **) (&func_glVertexAttrib4dARB) },
   { "glVertexAttrib4dNV", "glVertexAttrib4dNV", (void *) wine_glVertexAttrib4dNV, (void **) (&func_glVertexAttrib4dNV) },
+  { "glVertexAttrib4dv", "glVertexAttrib4dv", (void *) wine_glVertexAttrib4dv, (void **) (&func_glVertexAttrib4dv) },
   { "glVertexAttrib4dvARB", "glVertexAttrib4dvARB", (void *) wine_glVertexAttrib4dvARB, (void **) (&func_glVertexAttrib4dvARB) },
   { "glVertexAttrib4dvNV", "glVertexAttrib4dvNV", (void *) wine_glVertexAttrib4dvNV, (void **) (&func_glVertexAttrib4dvNV) },
+  { "glVertexAttrib4f", "glVertexAttrib4f", (void *) wine_glVertexAttrib4f, (void **) (&func_glVertexAttrib4f) },
   { "glVertexAttrib4fARB", "glVertexAttrib4fARB", (void *) wine_glVertexAttrib4fARB, (void **) (&func_glVertexAttrib4fARB) },
   { "glVertexAttrib4fNV", "glVertexAttrib4fNV", (void *) wine_glVertexAttrib4fNV, (void **) (&func_glVertexAttrib4fNV) },
+  { "glVertexAttrib4fv", "glVertexAttrib4fv", (void *) wine_glVertexAttrib4fv, (void **) (&func_glVertexAttrib4fv) },
   { "glVertexAttrib4fvARB", "glVertexAttrib4fvARB", (void *) wine_glVertexAttrib4fvARB, (void **) (&func_glVertexAttrib4fvARB) },
   { "glVertexAttrib4fvNV", "glVertexAttrib4fvNV", (void *) wine_glVertexAttrib4fvNV, (void **) (&func_glVertexAttrib4fvNV) },
   { "glVertexAttrib4hNV", "glVertexAttrib4hNV", (void *) wine_glVertexAttrib4hNV, (void **) (&func_glVertexAttrib4hNV) },
   { "glVertexAttrib4hvNV", "glVertexAttrib4hvNV", (void *) wine_glVertexAttrib4hvNV, (void **) (&func_glVertexAttrib4hvNV) },
+  { "glVertexAttrib4iv", "glVertexAttrib4iv", (void *) wine_glVertexAttrib4iv, (void **) (&func_glVertexAttrib4iv) },
   { "glVertexAttrib4ivARB", "glVertexAttrib4ivARB", (void *) wine_glVertexAttrib4ivARB, (void **) (&func_glVertexAttrib4ivARB) },
+  { "glVertexAttrib4s", "glVertexAttrib4s", (void *) wine_glVertexAttrib4s, (void **) (&func_glVertexAttrib4s) },
   { "glVertexAttrib4sARB", "glVertexAttrib4sARB", (void *) wine_glVertexAttrib4sARB, (void **) (&func_glVertexAttrib4sARB) },
   { "glVertexAttrib4sNV", "glVertexAttrib4sNV", (void *) wine_glVertexAttrib4sNV, (void **) (&func_glVertexAttrib4sNV) },
+  { "glVertexAttrib4sv", "glVertexAttrib4sv", (void *) wine_glVertexAttrib4sv, (void **) (&func_glVertexAttrib4sv) },
   { "glVertexAttrib4svARB", "glVertexAttrib4svARB", (void *) wine_glVertexAttrib4svARB, (void **) (&func_glVertexAttrib4svARB) },
   { "glVertexAttrib4svNV", "glVertexAttrib4svNV", (void *) wine_glVertexAttrib4svNV, (void **) (&func_glVertexAttrib4svNV) },
   { "glVertexAttrib4ubNV", "glVertexAttrib4ubNV", (void *) wine_glVertexAttrib4ubNV, (void **) (&func_glVertexAttrib4ubNV) },
+  { "glVertexAttrib4ubv", "glVertexAttrib4ubv", (void *) wine_glVertexAttrib4ubv, (void **) (&func_glVertexAttrib4ubv) },
   { "glVertexAttrib4ubvARB", "glVertexAttrib4ubvARB", (void *) wine_glVertexAttrib4ubvARB, (void **) (&func_glVertexAttrib4ubvARB) },
   { "glVertexAttrib4ubvNV", "glVertexAttrib4ubvNV", (void *) wine_glVertexAttrib4ubvNV, (void **) (&func_glVertexAttrib4ubvNV) },
+  { "glVertexAttrib4uiv", "glVertexAttrib4uiv", (void *) wine_glVertexAttrib4uiv, (void **) (&func_glVertexAttrib4uiv) },
   { "glVertexAttrib4uivARB", "glVertexAttrib4uivARB", (void *) wine_glVertexAttrib4uivARB, (void **) (&func_glVertexAttrib4uivARB) },
+  { "glVertexAttrib4usv", "glVertexAttrib4usv", (void *) wine_glVertexAttrib4usv, (void **) (&func_glVertexAttrib4usv) },
   { "glVertexAttrib4usvARB", "glVertexAttrib4usvARB", (void *) wine_glVertexAttrib4usvARB, (void **) (&func_glVertexAttrib4usvARB) },
   { "glVertexAttribArrayObjectATI", "glVertexAttribArrayObjectATI", (void *) wine_glVertexAttribArrayObjectATI, (void **) (&func_glVertexAttribArrayObjectATI) },
+  { "glVertexAttribPointer", "glVertexAttribPointer", (void *) wine_glVertexAttribPointer, (void **) (&func_glVertexAttribPointer) },
   { "glVertexAttribPointerARB", "glVertexAttribPointerARB", (void *) wine_glVertexAttribPointerARB, (void **) (&func_glVertexAttribPointerARB) },
   { "glVertexAttribPointerNV", "glVertexAttribPointerNV", (void *) wine_glVertexAttribPointerNV, (void **) (&func_glVertexAttribPointerNV) },
   { "glVertexAttribs1dvNV", "glVertexAttribs1dvNV", (void *) wine_glVertexAttribs1dvNV, (void **) (&func_glVertexAttribs1dvNV) },
@@ -3053,6 +3338,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glAttachShader( GLuint program, GLuint shader ) {
+  TRACE("(%d, %d)\n", program, shader );
+  ENTER_GL();
+  func_glAttachShader( program, shader );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glBeginFragmentShaderATI( ) {
   TRACE("()\n");
   ENTER_GL();
@@ -3088,6 +3380,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glBindAttribLocation( GLuint program, GLuint index, GLchar* name ) {
+  TRACE("(%d, %d, %p)\n", program, index, name );
+  ENTER_GL();
+  func_glBindAttribLocation( program, index, name );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glBindAttribLocationARB( unsigned int programObj, GLuint index, char* name ) {
   TRACE("(%d, %d, %p)\n", programObj, index, name );
   ENTER_GL();
@@ -3287,6 +3586,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glBlendEquationSeparate( GLenum modeRGB, GLenum modeAlpha ) {
+  TRACE("(%d, %d)\n", modeRGB, modeAlpha );
+  ENTER_GL();
+  func_glBlendEquationSeparate( modeRGB, modeAlpha );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glBlendEquationSeparateEXT( GLenum modeRGB, GLenum modeAlpha ) {
   TRACE("(%d, %d)\n", modeRGB, modeAlpha );
   ENTER_GL();
@@ -3352,6 +3658,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glClampColorARB( GLenum target, GLenum clamp ) {
+  TRACE("(%d, %d)\n", target, clamp );
+  ENTER_GL();
+  func_glClampColorARB( target, clamp );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glClientActiveTexture( GLenum texture ) {
   TRACE("(%d)\n", texture );
   ENTER_GL();
@@ -3583,6 +3896,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glCompileShader( GLuint shader ) {
+  TRACE("(%d)\n", shader );
+  ENTER_GL();
+  func_glCompileShader( shader );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glCompileShaderARB( unsigned int shaderObj ) {
   TRACE("(%d)\n", shaderObj );
   ENTER_GL();
@@ -3779,6 +4099,15 @@
   LEAVE_GL();
 }
 
+GLuint WINAPI wine_glCreateProgram( ) {
+  GLuint ret_value;
+  TRACE("()\n");
+  ENTER_GL();
+  ret_value = func_glCreateProgram( );
+  LEAVE_GL();
+  return ret_value;
+}
+
 unsigned int WINAPI wine_glCreateProgramObjectARB( ) {
   unsigned int ret_value;
   TRACE("()\n");
@@ -3788,6 +4117,15 @@
   return ret_value;
 }
 
+GLuint WINAPI wine_glCreateShader( GLenum type ) {
+  GLuint ret_value;
+  TRACE("(%d)\n", type );
+  ENTER_GL();
+  ret_value = func_glCreateShader( type );
+  LEAVE_GL();
+  return ret_value;
+}
+
 unsigned int WINAPI wine_glCreateShaderObjectARB( GLenum shaderType ) {
   unsigned int ret_value;
   TRACE("(%d)\n", shaderType );
@@ -3909,6 +4247,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glDeleteProgram( GLuint program ) {
+  TRACE("(%d)\n", program );
+  ENTER_GL();
+  func_glDeleteProgram( program );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glDeleteProgramsARB( GLsizei n, GLuint* programs ) {
   TRACE("(%d, %p)\n", n, programs );
   ENTER_GL();
@@ -3937,6 +4282,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glDeleteShader( GLuint shader ) {
+  TRACE("(%d)\n", shader );
+  ENTER_GL();
+  func_glDeleteShader( shader );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glDeleteTexturesEXT( GLsizei n, GLuint* textures ) {
   TRACE("(%d, %p)\n", n, textures );
   ENTER_GL();
@@ -3972,6 +4324,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glDetachShader( GLuint program, GLuint shader ) {
+  TRACE("(%d, %d)\n", program, shader );
+  ENTER_GL();
+  func_glDetachShader( program, shader );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glDetailTexFuncSGIS( GLenum target, GLsizei n, GLfloat* points ) {
   TRACE("(%d, %d, %p)\n", target, n, points );
   ENTER_GL();
@@ -3986,6 +4345,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glDisableVertexAttribArray( GLuint index ) {
+  TRACE("(%d)\n", index );
+  ENTER_GL();
+  func_glDisableVertexAttribArray( index );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glDisableVertexAttribArrayARB( GLuint index ) {
   TRACE("(%d)\n", index );
   ENTER_GL();
@@ -4007,6 +4373,20 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glDrawBuffers( GLsizei n, GLenum* bufs ) {
+  TRACE("(%d, %p)\n", n, bufs );
+  ENTER_GL();
+  func_glDrawBuffers( n, bufs );
+  LEAVE_GL();
+}
+
+void WINAPI wine_glDrawBuffersARB( GLsizei n, GLenum* bufs ) {
+  TRACE("(%d, %p)\n", n, bufs );
+  ENTER_GL();
+  func_glDrawBuffersARB( n, bufs );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glDrawBuffersATI( GLsizei n, GLenum* bufs ) {
   TRACE("(%d, %p)\n", n, bufs );
   ENTER_GL();
@@ -4091,6 +4471,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glEnableVertexAttribArray( GLuint index ) {
+  TRACE("(%d)\n", index );
+  ENTER_GL();
+  func_glEnableVertexAttribArray( index );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glEnableVertexAttribArrayARB( GLuint index ) {
   TRACE("(%d)\n", index );
   ENTER_GL();
@@ -4542,6 +4929,13 @@
   return ret_value;
 }
 
+void WINAPI wine_glGetActiveAttrib( GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name ) {
+  TRACE("(%d, %d, %d, %p, %p, %p, %p)\n", program, index, bufSize, length, size, type, name );
+  ENTER_GL();
+  func_glGetActiveAttrib( program, index, bufSize, length, size, type, name );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetActiveAttribARB( unsigned int programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, char* name ) {
   TRACE("(%d, %d, %d, %p, %p, %p, %p)\n", programObj, index, maxLength, length, size, type, name );
   ENTER_GL();
@@ -4549,6 +4943,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetActiveUniform( GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name ) {
+  TRACE("(%d, %d, %d, %p, %p, %p, %p)\n", program, index, bufSize, length, size, type, name );
+  ENTER_GL();
+  func_glGetActiveUniform( program, index, bufSize, length, size, type, name );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetActiveUniformARB( unsigned int programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, char* name ) {
   TRACE("(%d, %d, %d, %p, %p, %p, %p)\n", programObj, index, maxLength, length, size, type, name );
   ENTER_GL();
@@ -4577,6 +4978,22 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetAttachedShaders( GLuint program, GLsizei maxCount, GLsizei* count, GLuint* obj ) {
+  TRACE("(%d, %d, %p, %p)\n", program, maxCount, count, obj );
+  ENTER_GL();
+  func_glGetAttachedShaders( program, maxCount, count, obj );
+  LEAVE_GL();
+}
+
+GLint WINAPI wine_glGetAttribLocation( GLuint program, GLchar* name ) {
+  GLint ret_value;
+  TRACE("(%d, %p)\n", program, name );
+  ENTER_GL();
+  ret_value = func_glGetAttribLocation( program, name );
+  LEAVE_GL();
+  return ret_value;
+}
+
 GLint WINAPI wine_glGetAttribLocationARB( unsigned int programObj, char* name ) {
   GLint ret_value;
   TRACE("(%d, %p)\n", programObj, name );
@@ -5052,6 +5469,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetProgramInfoLog( GLuint program, GLsizei bufSize, GLsizei* length, GLchar* infoLog ) {
+  TRACE("(%d, %d, %p, %p)\n", program, bufSize, length, infoLog );
+  ENTER_GL();
+  func_glGetProgramInfoLog( program, bufSize, length, infoLog );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetProgramLocalParameterdvARB( GLenum target, GLuint index, GLdouble* params ) {
   TRACE("(%d, %d, %p)\n", target, index, params );
   ENTER_GL();
@@ -5108,6 +5532,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetProgramiv( GLuint program, GLenum pname, GLint* params ) {
+  TRACE("(%d, %d, %p)\n", program, pname, params );
+  ENTER_GL();
+  func_glGetProgramiv( program, pname, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetProgramivARB( GLenum target, GLenum pname, GLint* params ) {
   TRACE("(%d, %d, %p)\n", target, pname, params );
   ENTER_GL();
@@ -5171,6 +5602,20 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetShaderInfoLog( GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* infoLog ) {
+  TRACE("(%d, %d, %p, %p)\n", shader, bufSize, length, infoLog );
+  ENTER_GL();
+  func_glGetShaderInfoLog( shader, bufSize, length, infoLog );
+  LEAVE_GL();
+}
+
+void WINAPI wine_glGetShaderSource( GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* source ) {
+  TRACE("(%d, %d, %p, %p)\n", shader, bufSize, length, source );
+  ENTER_GL();
+  func_glGetShaderSource( shader, bufSize, length, source );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetShaderSourceARB( unsigned int obj, GLsizei maxLength, GLsizei* length, char* source ) {
   TRACE("(%d, %d, %p, %p)\n", obj, maxLength, length, source );
   ENTER_GL();
@@ -5178,6 +5623,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetShaderiv( GLuint shader, GLenum pname, GLint* params ) {
+  TRACE("(%d, %d, %p)\n", shader, pname, params );
+  ENTER_GL();
+  func_glGetShaderiv( shader, pname, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetSharpenTexFuncSGIS( GLenum target, GLfloat* points ) {
   TRACE("(%d, %p)\n", target, points );
   ENTER_GL();
@@ -5213,6 +5665,15 @@
   LEAVE_GL();
 }
 
+GLint WINAPI wine_glGetUniformLocation( GLuint program, GLchar* name ) {
+  GLint ret_value;
+  TRACE("(%d, %p)\n", program, name );
+  ENTER_GL();
+  ret_value = func_glGetUniformLocation( program, name );
+  LEAVE_GL();
+  return ret_value;
+}
+
 GLint WINAPI wine_glGetUniformLocationARB( unsigned int programObj, char* name ) {
   GLint ret_value;
   TRACE("(%d, %p)\n", programObj, name );
@@ -5222,6 +5683,13 @@
   return ret_value;
 }
 
+void WINAPI wine_glGetUniformfv( GLuint program, GLint location, GLfloat* params ) {
+  TRACE("(%d, %d, %p)\n", program, location, params );
+  ENTER_GL();
+  func_glGetUniformfv( program, location, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetUniformfvARB( unsigned int programObj, GLint location, GLfloat* params ) {
   TRACE("(%d, %d, %p)\n", programObj, location, params );
   ENTER_GL();
@@ -5229,6 +5697,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetUniformiv( GLuint program, GLint location, GLint* params ) {
+  TRACE("(%d, %d, %p)\n", program, location, params );
+  ENTER_GL();
+  func_glGetUniformiv( program, location, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetUniformivARB( unsigned int programObj, GLint location, GLint* params ) {
   TRACE("(%d, %d, %p)\n", programObj, location, params );
   ENTER_GL();
@@ -5292,6 +5767,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetVertexAttribPointerv( GLuint index, GLenum pname, GLvoid** pointer ) {
+  TRACE("(%d, %d, %p)\n", index, pname, pointer );
+  ENTER_GL();
+  func_glGetVertexAttribPointerv( index, pname, pointer );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetVertexAttribPointervARB( GLuint index, GLenum pname, GLvoid** pointer ) {
   TRACE("(%d, %d, %p)\n", index, pname, pointer );
   ENTER_GL();
@@ -5306,6 +5788,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetVertexAttribdv( GLuint index, GLenum pname, GLdouble* params ) {
+  TRACE("(%d, %d, %p)\n", index, pname, params );
+  ENTER_GL();
+  func_glGetVertexAttribdv( index, pname, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetVertexAttribdvARB( GLuint index, GLenum pname, GLdouble* params ) {
   TRACE("(%d, %d, %p)\n", index, pname, params );
   ENTER_GL();
@@ -5320,6 +5809,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetVertexAttribfv( GLuint index, GLenum pname, GLfloat* params ) {
+  TRACE("(%d, %d, %p)\n", index, pname, params );
+  ENTER_GL();
+  func_glGetVertexAttribfv( index, pname, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetVertexAttribfvARB( GLuint index, GLenum pname, GLfloat* params ) {
   TRACE("(%d, %d, %p)\n", index, pname, params );
   ENTER_GL();
@@ -5334,6 +5830,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glGetVertexAttribiv( GLuint index, GLenum pname, GLint* params ) {
+  TRACE("(%d, %d, %p)\n", index, pname, params );
+  ENTER_GL();
+  func_glGetVertexAttribiv( index, pname, params );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glGetVertexAttribivARB( GLuint index, GLenum pname, GLint* params ) {
   TRACE("(%d, %d, %p)\n", index, pname, params );
   ENTER_GL();
@@ -5558,6 +6061,15 @@
   return ret_value;
 }
 
+GLboolean WINAPI wine_glIsProgram( GLuint program ) {
+  GLboolean ret_value;
+  TRACE("(%d)\n", program );
+  ENTER_GL();
+  ret_value = func_glIsProgram( program );
+  LEAVE_GL();
+  return ret_value;
+}
+
 GLboolean WINAPI wine_glIsProgramARB( GLuint program ) {
   GLboolean ret_value;
   TRACE("(%d)\n", program );
@@ -5594,6 +6106,15 @@
   return ret_value;
 }
 
+GLboolean WINAPI wine_glIsShader( GLuint shader ) {
+  GLboolean ret_value;
+  TRACE("(%d)\n", shader );
+  ENTER_GL();
+  ret_value = func_glIsShader( shader );
+  LEAVE_GL();
+  return ret_value;
+}
+
 GLboolean WINAPI wine_glIsTextureEXT( GLuint texture ) {
   GLboolean ret_value;
   TRACE("(%d)\n", texture );
@@ -5628,6 +6149,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glLinkProgram( GLuint program ) {
+  TRACE("(%d)\n", program );
+  ENTER_GL();
+  func_glLinkProgram( program );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glLinkProgramARB( unsigned int programObj ) {
   TRACE("(%d)\n", programObj );
   ENTER_GL();
@@ -7714,6 +8242,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glShaderSource( GLuint shader, GLsizei count, GLchar** string, GLint* length ) {
+  TRACE("(%d, %d, %p, %p)\n", shader, count, string, length );
+  ENTER_GL();
+  func_glShaderSource( shader, count, string, length );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glShaderSourceARB( unsigned int shaderObj, GLsizei count, char** string, GLint* length ) {
   TRACE("(%d, %d, %p, %p)\n", shaderObj, count, string, length );
   ENTER_GL();
@@ -7763,6 +8298,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glStencilFuncSeparate( GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask ) {
+  TRACE("(%d, %d, %d, %d)\n", frontfunc, backfunc, ref, mask );
+  ENTER_GL();
+  func_glStencilFuncSeparate( frontfunc, backfunc, ref, mask );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glStencilFuncSeparateATI( GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask ) {
   TRACE("(%d, %d, %d, %d)\n", frontfunc, backfunc, ref, mask );
   ENTER_GL();
@@ -7770,6 +8312,20 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glStencilMaskSeparate( GLenum face, GLuint mask ) {
+  TRACE("(%d, %d)\n", face, mask );
+  ENTER_GL();
+  func_glStencilMaskSeparate( face, mask );
+  LEAVE_GL();
+}
+
+void WINAPI wine_glStencilOpSeparate( GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass ) {
+  TRACE("(%d, %d, %d, %d)\n", face, sfail, dpfail, dppass );
+  ENTER_GL();
+  func_glStencilOpSeparate( face, sfail, dpfail, dppass );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glStencilOpSeparateATI( GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass ) {
   TRACE("(%d, %d, %d, %d)\n", face, sfail, dpfail, dppass );
   ENTER_GL();
@@ -8182,6 +8738,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform1f( GLint location, GLfloat v0 ) {
+  TRACE("(%d, %f)\n", location, v0 );
+  ENTER_GL();
+  func_glUniform1f( location, v0 );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform1fARB( GLint location, GLfloat v0 ) {
   TRACE("(%d, %f)\n", location, v0 );
   ENTER_GL();
@@ -8189,6 +8752,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform1fv( GLint location, GLsizei count, GLfloat* value ) {
+  TRACE("(%d, %d, %p)\n", location, count, value );
+  ENTER_GL();
+  func_glUniform1fv( location, count, value );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform1fvARB( GLint location, GLsizei count, GLfloat* value ) {
   TRACE("(%d, %d, %p)\n", location, count, value );
   ENTER_GL();
@@ -8196,6 +8766,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform1i( GLint location, GLint v0 ) {
+  TRACE("(%d, %d)\n", location, v0 );
+  ENTER_GL();
+  func_glUniform1i( location, v0 );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform1iARB( GLint location, GLint v0 ) {
   TRACE("(%d, %d)\n", location, v0 );
   ENTER_GL();
@@ -8203,6 +8780,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform1iv( GLint location, GLsizei count, GLint* value ) {
+  TRACE("(%d, %d, %p)\n", location, count, value );
+  ENTER_GL();
+  func_glUniform1iv( location, count, value );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform1ivARB( GLint location, GLsizei count, GLint* value ) {
   TRACE("(%d, %d, %p)\n", location, count, value );
   ENTER_GL();
@@ -8210,6 +8794,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform2f( GLint location, GLfloat v0, GLfloat v1 ) {
+  TRACE("(%d, %f, %f)\n", location, v0, v1 );
+  ENTER_GL();
+  func_glUniform2f( location, v0, v1 );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform2fARB( GLint location, GLfloat v0, GLfloat v1 ) {
   TRACE("(%d, %f, %f)\n", location, v0, v1 );
   ENTER_GL();
@@ -8217,6 +8808,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform2fv( GLint location, GLsizei count, GLfloat* value ) {
+  TRACE("(%d, %d, %p)\n", location, count, value );
+  ENTER_GL();
+  func_glUniform2fv( location, count, value );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform2fvARB( GLint location, GLsizei count, GLfloat* value ) {
   TRACE("(%d, %d, %p)\n", location, count, value );
   ENTER_GL();
@@ -8224,6 +8822,13 @@
   LEAVE_GL();
 }
 
+void WINAPI wine_glUniform2i( GLint location, GLint v0, GLint v1 ) {
+  TRACE("(%d, %d, %d)\n", location, v0, v1 );
+  ENTER_GL();
+  func_glUniform2i( location, v0, v1 );
+  LEAVE_GL();
+}
+
 void WINAPI wine_glUniform2iARB( GLint location, GLint v0, GLint v1 ) {
   TRACE("(%d, %d, %d)\n", location, v0, v1 );
   ENTER_GL();
